	parameter (nlayers=200)
	real deltamodel(nlayers*2),vx(nlayers),vz(nlayers),
     *	dip(nlayers+1),zborder(nlayers+1),gammafix(nlayers)
        namelist /model/nl,vx,vz,gammafix,dip,zborder,dist
c In files
	open(1,file='congra.out',status='old')
	open(4,file='model.in',status='old')
c Out files
	open(7,file='model.out',status='unknown')
	open(22,file='/scr/reinaldo/vx.plot',status='unknown')
	open(23,file='/scr/reinaldo/vz.plot',status='unknown')

	read(4,model)

c	dz=(zborder(nl)-zborder(1))/nl
	write(22,*) 2*nl
	write(23,*) 2*nl
	call update(nl,vx,vz,gammafix,dip,zborder,deltamodel,
     *	zgeoi,dz,dist)
	write(7,model)
	stop
	end

	subroutine update(nl,vx,vz,gammafix,dip,zborder,deltamodel,
     *	zgeoi,dz,dist)
	parameter (nlayers=200)
	real deltamodel(2*nl),vx(nl),vz(nl),gammafix(nl),dip(nl+1),
     *	zborder(nl+1)
	pi=acos(-1.)
	a180opi=180./pi
	pio180=pi/180.
	write(*,*) 'scale ?'
	read(*,*) scale
	oneoscale=1./scale
	write(*,*) 'step length ?'
	read(*,*) factor
	factora=factor
	read(1,*) deltamodel

	do i=1,nl
		vx(i)=1./(1./vx(i)+(factor*deltamodel(i)/scale))
		vz(i)=1./(1./vz(i)+(factor*deltamodel(i+nl)/scale))
	enddo

c	do i=1,nl
c      		gammafix(i)=gammafix(i)+factor*deltamodel(i+2*nl)*a180opi
c	enddo
c

	call smooth(vx,nl)
	call smooth(vx,nl)
	call smooth(vz,nl)
	call smooth(vz,nl)
		
	do i=1,nl
	write(22,*) zborder(i) ,vx(i)
	write(22,*) zborder(i) +(zborder(i+1)-zborder(i))*0.9999,vx(i)
	write(23,*) zborder(i) ,vz(i)
	write(23,*) zborder(i) +(zborder(i+1)-zborder(i))*0.9999,vz(i)
	enddo
	return
	end 

        subroutine smooth(v,nl)
        parameter (nlayers=200)
        real v(nl),v_aux(nlayers)
        do i=1,nl
                v_aux(i)=v(i)
        enddo
        do i=2,nl-1
		v(i)=v_aux(i-1)*0.3333+v_aux(i)*0.3333+v_aux(i+1)*0.33333
        enddo
        return
        end
