	parameter (nlayers=200)
	real deltamodel(nlayers),vx(nlayers),vz(nlayers),
     *	dip(nlayers+1),zborder(nlayers+1),gammafix(nlayers)
        namelist /model/nl,vx,vz,gammafix,dip,zborder,dist
c In files
	open(1,file='congra.out',status='old')
	open(4,file='model.in',status='old')
c Out files
	open(7,file='model.out',status='unknown')
	open(22,file='/scr/reinaldo/vx.plot',status='unknown')

	read(4,model)

c	write(22,*) 2*nl
	call update(nl,vx,vz,gammafix,dip,zborder,deltamodel,
     *	zgeoi,dz,dist)
	write(7,model)
	stop
	end

	subroutine update(nl,vx,vz,gammafix,dip,zborder,deltamodel,
     *	zgeoi,dz,dist)
	parameter (nlayers=200)
	real deltamodel(nl),vx(nl),vz(nl),gammafix(nl),dip(nl+1),
     *	zborder(nl+1)
	write(*,*) 'step length ?'
	read(*,*) factor
	factora=factor
	read(1,*) deltamodel

	do i=1,nl
		vx(i)=1./(1./vx(i)+(factor*deltamodel(i)))
	enddo

	call smooth(vx,nl)
	call smooth(vx,nl)
	do i=1,nl
		vz(i)= vx(i)
	enddo

	do i=1,nl
	write(22,*) zborder(i) ,vx(i)
	write(22,*) zborder(i) +(zborder(i+1)-zborder(i))*0.9999,vx(i)
	enddo
	return
	end 

        subroutine smooth(v,nl)
        parameter (nlayers=200)
        real v(nl),v_aux(nlayers)
        do i=1,nl
                v_aux(i)=v(i)
        enddo
        do i=2,nl-1
		v(i)=v_aux(i-1)*0.3333+v_aux(i)*0.3333+v_aux(i+1)*0.33333
        enddo
        return
        end
