	 implicit none
	real vel(4000),depth(4000),vel1(800),depth1(800),
     *	array_real(1000,1000)
     	integer array(1000,1000),array1(1000,1000)
	real zmin,zmax,vmin,vmax,deltav,deltaz,dz
	integer nv,n
        character*60 file 
	write(*,*) ' Input file1 (velocities)?'
	read(*,'(a60)') file 
	open(1,file=file) 
	write(*,*) ' Input file2 (velocities)?' 
	read(*,'(a60)') file
	open(2,file=file) 
	open(3,file='/scr/reinaldo/plot_dif.out',
     *	form='unformatted')

	write(*,*) 'Zmin and Zmax in the profile ?'
	read(*,*) zmin,zmax
	write(*,*) 'Vmin and Vmax in the profile ?'
	read(*,*) vmin,vmax
	write(*,*) 'nv ?'
	read(*,*) nv
	read(1,*) n
	read(2,*) n
	write(*,*) 'n1= ',nv,' n2= ',n
	deltav=(vmax-vmin)/(nv-1)
	deltaz=(zmax-zmin)/(n-1)
	dz=(zmax-zmin)/(n-1)
	zmin=zmin+dz*0.5
	call execute(vmin,deltav,zmin,dz,n,dz,vel,vel1,depth,depth1,
     *	array,array1,nv,n,array_real)
	stop
	end

	subroutine execute(vmin,deltav,zmin,deltaz,n,dz,vel,vela,depth,
     *	deptha,array,array1,nv,nz,array_real)
	implicit none
	integer nv,nz,array(nv,nz),array1(nv,nz),n,iz,iv,ifile,i,
     *	ival1,ival2
	real vel(n),depth(n),vela(2*n),deptha(2*n),vmin,deltav,zmin,
     *	dz,deltaz,array_real(nv,nz)
	
	do iz=1,nz
		do iv=1,nv
		array(iv,iz)=0
		array1(iv,iz)=0
		enddo
	enddo

	do i=1,n
	deptha(i)=zmin+dz*(i-1)
	enddo
		do ifile=1,2
			
	read(ifile,*) vel

	call writevel(n,vel,deptha,vmin,deltav,zmin,deltaz,
     *	array,array1,nv,nz,ifile)

		enddo
	
	do iz=1,nz
		do iv=1,nv
		array(iv,iz)=array(iv,iz)+array1(iv,iz)
c		if(array(iv,iz).eq.8.or.array(iv,iz).eq.5) then
c		array(iv,iz)=10
		if(array(iv,iz).eq.8) then
		array(iv,iz)=10.
		else if(array(iv,iz).eq.5) then
c		array(iv,iz)=1
		array(iv,iz)=4
		else if(array(iv,iz).eq.3) then
c		array(iv,iz)=-1
		array(iv,iz)=1
		else if(array(iv,iz).eq.0.) then
		array(iv,iz)=10
		endif
		enddo
	enddo

	ival1=-10.
	ival2=10.
	array(1,1)=ival1
	array(2,1)=ival2
c	write(3) array
	write(*,*) nz
	do iz=1,nz
		do iv=1,nv
		array_real(iv,iz)=float(array(iv,iz))
		enddo
	enddo
	write(3) array_real
	return
	end

	subroutine writevel(n,vel,depth1,vmin,deltav,zmin,deltaz,
     *  array,array1,nv,nz,ifile)
	real vel(n),depth1(n),vmin,deltav,deltaz,zmin
	integer array(nv,nz),array1(nv,nz),ifile,n,nv,nz,i,iv,j
	write(*,*) ifile
	if(ifile.eq.1) then


		do i=1,n
			iv=(vel(i)-vmin)/deltav + 1
		   do j=iv-1,1,-1
		   array(j,i)=3
		   enddo
		enddo
	else
        	do i=1,n
        		iv=(vel(i)-vmin)/deltav + 1
                  do j=iv-1,1,-1
		  array1(j,i)=5
                  enddo
                enddo
	endif
	
	return
	end
